with Text_Io;
use Text_Io; 

package body Demo4_Frame_Package is
   Panel_Ptr : Xv_Panel_Ptr;
   Frame_Ptr : Xv_Frame_Ptr;
   Quit_Ptr  : Xv_Panel_Button_Ptr;
   Lines : Strings(1..2) := (Line1'Access,Line2'Access);

   procedure Initialize (V : in out Demo4_Frame) is
   begin
      V.Some_Data := 100;

      Frame_Ptr := new Xv_Frame;
      Set_Title(Frame_Ptr.all,"Hello World #4");
      Set_Pos(Frame_Ptr.all,100,100);
      Set_Size(Frame_Ptr.all,300,180);
      Set_Max_Size(Frame_Ptr.all,600,600);
      Set_Min_Size(Frame_Ptr.all,100,100);
      -- Show footer and set left and right footer
      Show_Footer(Frame_Ptr.all);
      Set_Left_Footer(Frame_Ptr.all,"Left footer text");
      Set_Right_Footer(Frame_Ptr.all,"Right footer text");
      
      -- Create the panel (add True if you want 3D panel)
      Panel_Ptr := new Xv_Panel(Get_Frame(Frame_Ptr.all),True);
      
      -- Create the Quit button and set the callback function
      Quit_Ptr := new Xv_Panel_button(Get_Panel(Panel_Ptr.all));
      Set_Text(Quit_Ptr.all,"Quit");
      Set_Callback(Quit_Ptr.all,Quit_Func'Access);

      -- And off we go...
      Window_Loop(frame_Ptr.all);
   end Initialize;
   
   procedure Finalize (V : in out Demo4_Frame) is
   begin
      null;
   end Finalize;

   procedure Quit_Func(Item : Panel_Item;  Event : Integer) is
      Notice_Ptr  : Xv_Notice_Ptr;
      Buttons_Ptr : Notice_Buttons_ptr;
   begin 
      Buttons_Ptr := new Notice_Buttons(5);
      Set_Text(Buttons_Ptr,1,"Yeah");
      Set_Value(Buttons_Ptr,1,101);
      Set_Text(Buttons_Ptr,2,"Nop");
      Set_Value(Buttons_Ptr,2,102);
      Set_Text(Buttons_Ptr,3,"Skip");
      Set_Value(Buttons_Ptr,3,103);
      Set_Text(Buttons_Ptr,4,"Cancel");
      Set_Value(Buttons_Ptr,4,104);
      Set_Text(Buttons_Ptr,5,"Quit");
      Set_Value(Buttons_Ptr,5,105);

      Notice_Ptr := new Xv_Notice (Xv_Opaque(Get_Panel(Panel_Ptr.all)),1);
      Set_Text(Notice_Ptr.all,Lines);
      Set_Buttons(Notice_Ptr.all,Buttons_Ptr);
      Show_Notice(Notice_Ptr.all);

      case Get_Choosen(Notice_Ptr.all) is
	 when 101 =>
	    Put_Line("You pressed YES");
	 when 102 =>
	    Put_Line("You pressed NOP");
	 when 103 =>
	    Put_Line("You pressed SKIP");
	 when 104 =>
	    Put_Line("You pressed CANCEL");
	 when 105 =>
	    Put_Line("You pressed QUIT");
	 when others =>
	    New_Line;
      end case;

      raise QUIT_PROGRAM;
   end quit_func;
end Demo4_Frame_Package;
